

do
	local millingResults = {
		[765] = { -- Silverleaf
			[39151] = 2.5, --Alabaster Pigment
		},
		[2447] = { -- Peacebloom
			[39151] = 2.5, --Alabaster Pigment
		},
		[2449] = { -- Earthroot
			[39151] = 2.996, --Alabaster Pigment
		},
		[785] = { -- Mageroyal
			[39334] = 2.498, --Dusky Pigment
			[43103] = 0.269, --Verdant Pigment
		},
		[2450] = { -- Briarthorn
			[39334] = 2.498, --Dusky Pigment
			[43103] = 0.265, --Verdant Pigment
		},
		[2452] = { -- Swiftthistle
			[39334] = 2.497, --Dusky Pigment
			[43103] = 0.266, --Verdant Pigment
		},
		[2453] = { -- Bruiseweed
			[39334] = 3, --Dusky Pigment
			[43103] = 0.537, --Verdant Pigment
		},
		[3820] = { -- Stranglekelp
			[39334] = 3.009, --Dusky Pigment
			[43103] = 0.534, --Verdant Pigment
		},
		[3369] = { -- Grave Moss
			[39338] = 2.501, --Golden Pigment
			[43104] = 0.277, --Burnt Pigment
		},
		[3355] = { -- Wild Steelbloom
			[39338] = 2.5, --Golden Pigment
			[43104] = 0.264, --Burnt Pigment
		},
		[3356] = { -- Kingsblood
			[39338] = 2.998, --Golden Pigment
			[43104] = 0.534, --Burnt Pigment
		},
		[3357] = { -- Liferoot
			[39338] = 3, --Golden Pigment
			[43104] = 0.54, --Burnt Pigment
		},
		[3818] = { -- Fadeleaf
			[39339] = 2.495, --Emerald Pigment
			[43105] = 0.261, --Indigo Pigment
		},
		[3821] = { -- Goldthorn
			[39339] = 2.49, --Emerald Pigment
			[43105] = 0.27, --Indigo Pigment
		},
		[3358] = { -- Khadgar's Whisker
			[39339] = 3.501, --Emerald Pigment
			[43105] = 0.533, --Indigo Pigment
		},
		[3819] = { -- Dragon's Teeth
			[39339] = 3.491, --Emerald Pigment
			[43105] = 0.533, --Indigo Pigment
		},
		[4625] = { -- Firebloom
			[39340] = 2.505, --Violet Pigment
			[43106] = 0.273, --Ruby Pigment
		},
		[8831] = { -- Purple Lotus
			[39340] = 2.499, --Violet Pigment
			[43106] = 0.258, --Ruby Pigment
		},
		[8836] = { -- Arthas' Tears
			[39340] = 2.503, --Violet Pigment
			[43106] = 0.27, --Ruby Pigment
		},
		[8838] = { -- Sungrass
			[39340] = 2.499, --Violet Pigment
			[43106] = 0.265, --Ruby Pigment
		},
		[8845] = { -- Ghost Mushroom
			[39340] = 2.99, --Violet Pigment
			[43106] = 0.539, --Ruby Pigment
		},
		[8839] = { -- Blindweed
			[39340] = 2.998, --Violet Pigment
			[43106] = 0.527, --Ruby Pigment
		},
		[8846] = { -- Gromsblood
			[39340] = 3.003, --Violet Pigment
			[43106] = 0.535, --Ruby Pigment
		},
		[13464] = { -- Golden Sansam
			[43107] = 0.264, --Sapphire Pigment
			[39341] = 2.505, --Silvery Pigment
		},
		[13463] = { -- Dreamfoil
			[43107] = 0.268, --Sapphire Pigment
			[39341] = 2.5, --Silvery Pigment
		},
		[13465] = { -- Mountain Silversage
			[43107] = 0.533, --Sapphire Pigment
			[39341] = 3.012, --Silvery Pigment
		},
		[13466] = { -- Sorrowmoss
			[43107] = 0.537, --Sapphire Pigment
			[39341] = 3.001, --Silvery Pigment
		},
		[13467] = { -- Icecap
			[43107] = 0.537, --Sapphire Pigment
			[39341] = 3, --Silvery Pigment
		},
		[22785] = { -- Felweed
			[43108] = 0.264, --Ebon Pigment
			[39342] = 2.5, --Nether Pigment
		},
		[22786] = { -- Dreaming Glory
			[43108] = 0.264, --Ebon Pigment
			[39342] = 2.5, --Nether Pigment
		},
		[22789] = { -- Terocone
			[43108] = 0.263, --Ebon Pigment
			[39342] = 2.493, --Nether Pigment
		},
		[22787] = { -- Ragveil
			[43108] = 0.272, --Ebon Pigment
			[39342] = 2.503, --Nether Pigment
		},
		[22790] = { -- Ancient Lichen
			[43108] = 0.534, --Ebon Pigment
			[39342] = 2.994, --Nether Pigment
		},
		[22791] = { -- Netherbloom
			[43108] = 0.546, --Ebon Pigment
			[39342] = 2.998, --Nether Pigment
		},
		[22792] = { -- Nightmare Vine
			[43108] = 0.56, --Ebon Pigment
			[39342] = 2.996, --Nether Pigment
		},
		[22793] = { -- Mana Thistle
			[43108] = 0.527, --Ebon Pigment
			[39342] = 3.019, --Nether Pigment
		},
		[36907] = { -- Talandra's Rose
			[43109] = 0.266, --Icy Pigment
			[39343] = 2.503, --Azure Pigment
		},
		[37921] = { -- Deadnettle
			[43109] = 0.267, --Icy Pigment
			[39343] = 2.5, --Azure Pigment
		},
		[36904] = { -- Tiger Lily
			[43109] = 0.266, --Icy Pigment
			[39343] = 2.502, --Azure Pigment
		},
		[36901] = { -- Goldclover
			[43109] = 0.266, --Icy Pigment
			[39343] = 2.5, --Azure Pigment
		},
		[39970] = { -- Fire Leaf
			[43109] = 0.269, --Icy Pigment
			[39343] = 2.5, --Azure Pigment
		},
		[39969] = { -- Fire Seed
			[43109] = 0.238, --Icy Pigment
			[39343] = 2.621, --Azure Pigment
		},
		[36903] = { -- Adder's Tongue
			[43109] = 0.536, --Icy Pigment
			[39343] = 3.002, --Azure Pigment
		},
		[36905] = { -- Lichbloom
			[43109] = 0.537, --Icy Pigment
			[39343] = 3.001, --Azure Pigment
		},
		[36906] = { -- Icethorn
			[43109] = 0.538, --Icy Pigment
			[39343] = 2.989, --Azure Pigment
		},
		[52983] = { -- Cinderbloom
			[61979] = 2.499, --Ashen Pigment
			[61980] = 0.265, --Burning Embers
		},
		[52984] = { -- Stormvine
			[61979] = 2.502, --Ashen Pigment
			[61980] = 0.266, --Burning Embers
		},
		[52985] = { -- Azshara's Veil
			[61979] = 2.502, --Ashen Pigment
			[61980] = 0.267, --Burning Embers
		},
		[52986] = { -- Heartblossom
			[61979] = 2.501, --Ashen Pigment
			[61980] = 0.266, --Burning Embers
		},
		[52988] = { -- Whiptail
			[61979] = 2.999, --Ashen Pigment
			[61980] = 0.536, --Burning Embers
		},
		[72234] = { -- Green Tea Leaf
			[79251] = 2.501, --Shadow Pigment
			[79253] = 0.272, --Misty Pigment
		},
		[89639] = { -- Desecrated Herb
			[79251] = 2.473, --Shadow Pigment
			[79253] = 0.276, --Misty Pigment
		},
		[52987] = { -- Twilight Jasmine
			[61979] = 3, --Ashen Pigment
			[61980] = 0.533, --Burning Embers
		},
		[72237] = { -- Rain Poppy
			[79251] = 2.504, --Shadow Pigment
			[79253] = 0.267, --Misty Pigment
		},
		[72235] = { -- Silkweed
			[79251] = 2.493, --Shadow Pigment
			[79253] = 0.279, --Misty Pigment
		},
		[79010] = { -- Snow Lily
			[79251] = 2.499, --Shadow Pigment
			[79253] = 0.254, --Misty Pigment
		},
		[79011] = { -- Fool's Cap
			[79251] = 3.004, --Shadow Pigment
			[79253] = 0.541, --Misty Pigment
		},
	}

	local millBrackets =
	{
		[765] = 1, -- Silverleaf
		[2447] = 1, -- Peacebloom
		[2449] = 1, -- Earthroot
		[785] = 1, -- Mageroyal
		[2450] = 25, -- Briarthorn
		[2452] = 25, -- Swiftthistle
		[2453] = 25, -- Bruiseweed
		[3820] = 25, -- Stranglekelp
		[3369] = 75, -- Grave Moss
		[3355] = 75, -- Wild Steelbloom
		[3356] = 75, -- Kingsblood
		[3357] = 75, -- Liferoot
		[3818] = 125, -- Fadeleaf
		[3821] = 125, -- Goldthorn
		[3358] = 125, -- Khadgar's Whisker
		[3819] = 125, -- Dragon's Teeth
		[4625] = 175, -- Firebloom
		[8831] = 175, -- Purple Lotus
		[8836] = 175, -- Arthas' Tears
		[8838] = 175, -- Sungrass
		[8845] = 175, -- Ghost Mushroom
		[8839] = 175, -- Blindweed
		[8846] = 175, -- Gromsblood
		[13464] = 225, -- Golden Sansam
		[13463] = 225, -- Dreamfoil
		[13465] = 225, -- Mountain Silversage
		[13466] = 225, -- Sorrowmoss
		[13467] = 200, -- Icecap
		[22785] = 275, -- Felweed
		[22786] = 275, -- Dreaming Glory
		[22789] = 275, -- Terocone
		[22787] = 275, -- Ragveil
		[22790] = 275, -- Ancient Lichen
		[22791] = 275, -- Netherbloom
		[22792] = 275, -- Nightmare Vine
		[22793] = 275, -- Mana Thistle
		[36907] = 325, -- Talandra's Rose
		[37921] = 325, -- Deadnettle
		[36904] = 325, -- Tiger Lily
		[36901] = 325, -- Goldclover
		[39970] = 325, -- Fire Leaf
		[39969] = 325, -- Fire Seed
		[36903] = 325, -- Adder's Tongue
		[36905] = 325, -- Lichbloom
		[36906] = 325, -- Icethorn
		[52983] = 425, -- Cinderbloom
		[52984] = 425, -- Stormvine
		[52985] = 450, -- Azshara's Veil
		[52986] = 450, -- Heartblossom
		[52988] = 475, -- Whiptail
		[72234] = 500, -- Green Tea Leaf
		[89639] = 500, -- Desecrated Herb
		[52987] = 475, -- Twilight Jasmine
		[72237] = 500, -- Rain Poppy
		[72235] = 500, -- Silkweed
		[79010] = 500, -- Snow Lily
		[79011] = 500, -- Fool's Cap
	}



	local millingLevels = {
		[1] = { "playerMillLevel", 1},
		[25] = { "playerMillLevel", 25},
		[75] = { "playerMillLevel", 75},
		[125] = { "playerMillLevel", 125},
		[175] = { "playerMillLevel", 175},
		[225] = { "playerMillLevel", 225},
		[275] = { "playerMillLevel", 275},
		[325] = { "playerMillLevel", 325},
		[425] = { "playerMillLevel", 425},
		[450] = { "playerMillLevel", 450},
		[475] = { "playerMillLevel", 475},
		[500] = { "playerMillLevel", 500},
	}


	local millingLevels = { 1,25,75,125,175,225,275,325,425,450,475, 500 }

	local pigmentSources = {}

	local millingReagents = {}

	local millingNames = {}


	local skillList = {}

	local api = {}



	-- spoof recipes for milled herbs -> pigments
	GnomeWorks:RegisterMessageDispatch("AddSpoofedRecipes", function ()
		local trade,recipeList  = GnomeWorks:AddPseudoTrade(51005, api)
		local millGroup = 1

		trade.priority = .75

		for k,bracket in pairs(millingLevels) do
			skillList[#skillList + 1] = "Milling Group "..millGroup

			millGroup = millGroup +1

			for herbID, pigmentTable in pairs(millingResults) do
				if millBrackets[herbID] == bracket then
					skillList[#skillList + 1] = -herbID

					recipeList[-herbID] = trade

					millingReagents[-herbID] = { [herbID] = 5 }
					millingNames[-herbID] = string.format("Mill %s",GetItemInfo(herbID) or "item:"..herbID)

					GnomeWorks:AddToReagentCache(herbID, -herbID, 5)

					for pigmentID, numMade in pairs(pigmentTable) do
						GnomeWorks:AddToItemCache(pigmentID, -herbID, numMade)
					end
				end
			end
		end

		trade.skillList = skillList

		GnomeWorks.system.levelBasis[51005] = 45357

		api.RecordKnownSpells((UnitName("player")))

		return true
	end)



	api.DoTradeSkill = function(recipeID)
		CastSpellByName("/use "..GetSpellInfo(-recipeID))
	end

	api.GetRecipeName = function(recipeID)
		if type(recipeID) == "string" then
			return recipeID
		end

		if millingNames[recipeID] then
			if string.find(millingNames[recipeID],"item:") and GetItemInfo(-recipeID) then
				millingNames[recipeID] = string.format("Mill %s",GetItemInfo(-recipeID))
			end

			return millingNames[recipeID]
		end
	end

	api.GetRecipeData = function(recipeID)
		if millingResults[-recipeID] then
			return millingResults[-recipeID], millingReagents[recipeID], 51005
		end
	end



	api.GetNumTradeSkills = function()
		return #skillList
	end


	api.GetTradeSkillItemLink = function(index)
		local recipeID = skillList[index]

		if not recipeID then return end

		if type(recipeID) == "string" then
			return
		end

		local itemID = next(millingResults[-recipeID])

		local _,link = GetItemInfo(itemID)

		return link
	end


	api.GetTradeSkillRecipeLink = function(index)
		local recipeID = skillList[index]

		if type(recipeID) == "string" then
			return
		end

		return "|cff80a0ff|Henchant:"..recipeID.."|h["..millingNames[recipeID].."]|h|r", recipeID
	end


	api.GetTradeSkillLine = function()
		return (GetSpellInfo(51005)), 1, 1
	end


	api.GetTradeSkillInfo = function(index)
		local recipeID = skillList[index]

		if type(recipeID) == "string" then
			return recipeID, "header"
		end

		if recipeID then
			if millingNames[-recipeID] then
				if string.find(millingNames[-recipeID],"item:") and GetItemInfo(recipeID) then
					millingNames[-recipeID] = string.format("Mill %s",GetItemInfo(recipeID))
				end
			end

			return millingNames[-recipeID], "optimal"
		end
	end


	api.GetTradeSkillIcon = function(index)
		local recipeID = skillList[index]

		if type(recipeID) == "string" then
			return
		end

		local itemID = next(millingResults[-recipeID])

		return GetItemIcon(itemID)
	end


	api.IsTradeSkillLinked = function()
		return true
	end




	api.ConfigureMacroText = function(recipeID)
		GnomeWorks:Restack(-recipeID, 5)
		return "/cast "..GetSpellInfo(51005).."\r/use "..GetItemInfo(-recipeID)
	end


	api.RecordKnownSpells = function(player)
		local inscriptionRank = GnomeWorks:GetTradeSkillRank(player, 45357)

		if inscriptionRank > 0 then
			local knownSpells = GnomeWorks.data.knownSpells[player]


			for i = 1, #skillList, 1 do
				if type(skillList[i]) ~= "string" then

					local recipeID = skillList[i]
					local herbID = -recipeID

					if millBrackets[herbID] <= inscriptionRank then
						knownSpells[recipeID] = i
					end
				end
			end
		end
	end


	api.Scan = function()
		if not GnomeWorks.tradeID then
			return
		end

		local tradeID = GnomeWorks.tradeID
		local player = GnomeWorks.player

		local key = player..":"..tradeID

		local lastHeader = nil
		local gotNil = false

		local currentGroup = nil

		local mainGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"By Bracket")

		local flatGroup = GnomeWorks:RecipeGroupNew(player,tradeID,"Flat")

		flatGroup.locked = true
		flatGroup.autoGroup = true

		GnomeWorks:RecipeGroupClearEntries(flatGroup)

		local groupList = {}

		local numHeaders = 0

		api.RecordKnownSpells(player)

		for i = 1, #skillList, 1 do
			local subSpell, extra

			if type(skillList[i]) == "string" then
				local groupName = skillList[i]

				numHeaders = numHeaders + 1

				currentGroup = GnomeWorks:RecipeGroupNew(player, tradeID, "By Bracket", groupName)
				currentGroup.autoGroup = true

				GnomeWorks:RecipeGroupAddSubGroup(mainGroup, currentGroup, i, true)
			else
				local recipeID = skillList[i]

				if GnomeWorks:IsSpellKnown(recipeID, player) then
					GnomeWorks:RecipeGroupAddRecipe(flatGroup, recipeID, i, true)

					if currentGroup then
						GnomeWorks:RecipeGroupAddRecipe(currentGroup, recipeID, i, true)
					else
						GnomeWorks:RecipeGroupAddRecipe(mainGroup, recipeID, i, true)
					end
				end

--				difficulty[i] = "optimal"


--				skillIndexLookup[recipeID] = i
			end
		end

		GnomeWorks:InventoryScan()

--		GnomeWorks:ScheduleTimer("UpdateMainWindow",.1)
		GnomeWorks:SendMessageDispatch("TradeScanComplete")
		return
	end

end





